Index: palm/trunk/SOURCE/Makefile
===================================================================
--- palm/trunk/SOURCE/Makefile	(revision 1762)
+++ palm/trunk/SOURCE/Makefile	(revision 1763)
@@ -20,9 +20,12 @@
 # Current revisions:
 # ------------------
-# +pmc_interface, +pmc routines
+#
 # 
 # Former revisions:
 # -----------------
 # $Id$
+# 
+# 1762 2016-02-25 12:31:13Z hellstea
+# +pmc_interface, +pmc routines 
 #
 # 1747 2016-02-08 12:25:53Z raasch
Index: palm/trunk/SOURCE/boundary_conds.f90
===================================================================
--- palm/trunk/SOURCE/boundary_conds.f90	(revision 1762)
+++ palm/trunk/SOURCE/boundary_conds.f90	(revision 1763)
@@ -19,9 +19,12 @@
 ! Current revisions:
 ! -----------------
-! Introduction of nested domain feature
+! 
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1762 2016-02-25 12:31:13Z hellstea
+! Introduction of nested domain feature
 !
 ! 1742 2016-01-13 09:50:06Z raasch
Index: palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- palm/trunk/SOURCE/check_parameters.f90	(revision 1762)
+++ palm/trunk/SOURCE/check_parameters.f90	(revision 1763)
@@ -19,9 +19,12 @@
 ! Current revisions:
 ! -----------------
-! Introduction of nested domain feature
+! 
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1762 2016-02-25 12:31:13Z hellstea
+! Introduction of nested domain feature
 !
 ! 1745 2016-02-05 13:06:51Z gronemeier
Index: palm/trunk/SOURCE/exchange_horiz_2d.f90
===================================================================
--- palm/trunk/SOURCE/exchange_horiz_2d.f90	(revision 1762)
+++ palm/trunk/SOURCE/exchange_horiz_2d.f90	(revision 1763)
@@ -19,9 +19,12 @@
 ! Current revisions:
 ! -----------------
-! Introduction of nested domain feature
+!
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1762 2016-02-25 12:31:13Z hellstea
+! Introduction of nested domain feature
 !
 ! 1682 2015-10-07 23:56:08Z knoop
Index: palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- palm/trunk/SOURCE/init_3d_model.f90	(revision 1762)
+++ palm/trunk/SOURCE/init_3d_model.f90	(revision 1763)
@@ -19,9 +19,12 @@
 ! Current revisions:
 ! ------------------
-! Introduction of nested domain feature
+! 
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1762 2016-02-25 12:31:13Z hellstea
+! Introduction of nested domain feature
 !
 ! 1738 2015-12-18 13:56:05Z raasch
Index: palm/trunk/SOURCE/init_grid.f90
===================================================================
--- palm/trunk/SOURCE/init_grid.f90	(revision 1762)
+++ palm/trunk/SOURCE/init_grid.f90	(revision 1763)
@@ -19,9 +19,12 @@
 ! Current revisions:
 ! -----------------
-! Introduction of nested domain feature
+! 
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1762 2016-02-25 12:31:13Z hellstea
+! Introduction of nested domain feature
 !
 ! 1743 2016-01-13 10:23:51Z raasch
Index: palm/trunk/SOURCE/init_pegrid.f90
===================================================================
--- palm/trunk/SOURCE/init_pegrid.f90	(revision 1762)
+++ palm/trunk/SOURCE/init_pegrid.f90	(revision 1763)
@@ -19,9 +19,12 @@
 ! Current revisions:
 ! ------------------
-! Introduction of nested domain feature
+!
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1762 2016-02-25 12:31:13Z hellstea
+! Introduction of nested domain feature
 !
 ! 1682 2015-10-07 23:56:08Z knoop
Index: palm/trunk/SOURCE/modules.f90
===================================================================
--- palm/trunk/SOURCE/modules.f90	(revision 1762)
+++ palm/trunk/SOURCE/modules.f90	(revision 1763)
@@ -19,9 +19,12 @@
 ! Current revisions:
 ! ------------------
-! +nest_* variables, size of volume_flow arrays increased by one element
+! 
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1762 2016-02-25 12:31:13Z hellstea
+! +nest_* variables, size of volume_flow arrays increased by one element
 !
 ! 1738 2015-12-18 13:56:05Z raasch
Index: palm/trunk/SOURCE/palm.f90
===================================================================
--- palm/trunk/SOURCE/palm.f90	(revision 1762)
+++ palm/trunk/SOURCE/palm.f90	(revision 1763)
@@ -19,9 +19,12 @@
 ! Current revisions:
 ! -----------------
-! Introduction of nested domain feature
+!
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1762 2016-02-25 12:31:13Z hellstea
+! Introduction of nested domain feature
 !
 ! 1747 2016-02-08 12:25:53Z raasch
Index: palm/trunk/SOURCE/parin.f90
===================================================================
--- palm/trunk/SOURCE/parin.f90	(revision 1762)
+++ palm/trunk/SOURCE/parin.f90	(revision 1763)
@@ -19,9 +19,12 @@
 ! Current revisions:
 ! -----------------
-! Introduction of nested domain feature
+!
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1762 2016-02-25 12:31:13Z hellstea
+! Introduction of nested domain feature
 !
 ! 1691 2015-10-26 16:17:44Z maronga
Index: palm/trunk/SOURCE/pmc_client.f90
===================================================================
--- palm/trunk/SOURCE/pmc_client.f90	(revision 1762)
+++ palm/trunk/SOURCE/pmc_client.f90	(revision 1763)
@@ -21,9 +21,11 @@
 ! ------------------
 !
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
 !
-! Intoduction of the pure FORTRAN Palm Model Coupler     (PMC)  12.11.2015  K. Ketelsen
+! 1762 2016-02-25 12:31:13Z hellstea
+! Initial revision by K. Ketelsen
 !
 ! Description:
Index: palm/trunk/SOURCE/pmc_general.f90
===================================================================
--- palm/trunk/SOURCE/pmc_general.f90	(revision 1762)
+++ palm/trunk/SOURCE/pmc_general.f90	(revision 1763)
@@ -21,9 +21,11 @@
 ! ------------------
 !
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
 !
-! Intoduction of the pure FORTRAN Palm Model Coupler     (PMC)  12.11.2015  K. Ketelsen
+! 1762 2016-02-25 12:31:13Z hellstea
+! Initial revision by K. Ketelsen
 !
 ! Description:
Index: palm/trunk/SOURCE/pmc_handle_communicator.f90
===================================================================
--- palm/trunk/SOURCE/pmc_handle_communicator.f90	(revision 1762)
+++ palm/trunk/SOURCE/pmc_handle_communicator.f90	(revision 1763)
@@ -22,7 +22,11 @@
 ! ------------------
 !
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1762 2016-02-25 12:31:13Z hellstea
+! Initial revision by K. Ketelsen
 !
 ! Intoduction of the pure FORTRAN Palm Model Coupler     (PMC)  12.11.2015  K. Ketelsen
Index: palm/trunk/SOURCE/pmc_interface.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface.f90	(revision 1762)
+++ palm/trunk/SOURCE/pmc_interface.f90	(revision 1763)
@@ -26,7 +26,6 @@
 ! $Id$
 !
-! Renamed into pmc_interface                             23.02.2016  A. Hellsten & S. Raasch
-! Renamed into pmc_palm_interface                        12.11.2015  K. Ketelsen
-! Intoduction of the pure FORTRAN Palm Model Coupler     (PMC)
+! 1762 2016-02-25 12:31:13Z hellstea
+! Initial revision by A. Hellsten
 !
 ! Description:
Index: palm/trunk/SOURCE/pmc_mpi_wrapper.f90
===================================================================
--- palm/trunk/SOURCE/pmc_mpi_wrapper.f90	(revision 1762)
+++ palm/trunk/SOURCE/pmc_mpi_wrapper.f90	(revision 1763)
@@ -21,9 +21,11 @@
 ! ------------------
 !
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
 !
-! Intoduction of the pure FORTRAN Palm Model Coupler     (PMC)  12.11.2015  K. Ketelsen
+! 1762 2016-02-25 12:31:13Z hellstea
+! Initial revision by K. Ketelsen
 !
 ! Description:
Index: palm/trunk/SOURCE/pmc_server.f90
===================================================================
--- palm/trunk/SOURCE/pmc_server.f90	(revision 1762)
+++ palm/trunk/SOURCE/pmc_server.f90	(revision 1763)
@@ -21,9 +21,11 @@
 ! ------------------
 !
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
 !
-! Intoduction of the pure FORTRAN Palm Model Coupler     (PMC)  12.11.2015  K. Ketelsen
+! 1762 2016-02-25 12:31:13Z hellstea
+! Initial revision by K. Ketelsen
 !
 ! Description:
Index: palm/trunk/SOURCE/poismg.f90
===================================================================
--- palm/trunk/SOURCE/poismg.f90	(revision 1762)
+++ palm/trunk/SOURCE/poismg.f90	(revision 1763)
@@ -19,9 +19,12 @@
 ! Current revisions:
 ! -----------------
-! Introduction of nested domain feature
+!
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1762 2016-02-25 12:31:13Z hellstea
+! Introduction of nested domain feature
 !
 ! 1682 2015-10-07 23:56:08Z knoop
Index: palm/trunk/SOURCE/poismg_fast.f90
===================================================================
--- palm/trunk/SOURCE/poismg_fast.f90	(revision 1762)
+++ palm/trunk/SOURCE/poismg_fast.f90	(revision 1763)
@@ -19,9 +19,12 @@
 ! Current revisions:
 ! -----------------
-! Introduction of nested domain feature
+!
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1762 2016-02-25 12:31:13Z hellstea
+! Introduction of nested domain feature
 !
 ! 1682 2015-10-07 23:56:08Z knoop
Index: palm/trunk/SOURCE/pres.f90
===================================================================
--- palm/trunk/SOURCE/pres.f90	(revision 1762)
+++ palm/trunk/SOURCE/pres.f90	(revision 1763)
@@ -19,9 +19,12 @@
 ! Current revisions:
 ! ------------------
-! Introduction of nested domain feature
+!
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1762 2016-02-25 12:31:13Z hellstea
+! Introduction of nested domain feature
 !
 ! 1682 2015-10-07 23:56:08Z knoop
Index: palm/trunk/SOURCE/sor.f90
===================================================================
--- palm/trunk/SOURCE/sor.f90	(revision 1762)
+++ palm/trunk/SOURCE/sor.f90	(revision 1763)
@@ -19,9 +19,12 @@
 ! Current revisions:
 ! -----------------
-! Introduction of nested domain feature
+!
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1762 2016-02-25 12:31:13Z hellstea
+! Introduction of nested domain feature
 !
 ! 1682 2015-10-07 23:56:08Z knoop
Index: palm/trunk/SOURCE/time_integration.f90
===================================================================
--- palm/trunk/SOURCE/time_integration.f90	(revision 1762)
+++ palm/trunk/SOURCE/time_integration.f90	(revision 1763)
@@ -19,9 +19,12 @@
 ! Current revisions:
 ! ------------------
-! Introduction of nested domain feature
+!
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1762 2016-02-25 12:31:13Z hellstea
+! Introduction of nested domain feature
 !
 ! 1736 2015-12-04 08:56:33Z raasch