Index: /palm/trunk/SOURCE/Makefile
===================================================================
--- /palm/trunk/SOURCE/Makefile	(revision 1764)
+++ /palm/trunk/SOURCE/Makefile	(revision 1765)
@@ -20,11 +20,13 @@
 # Current revisions:
 # ------------------
-# update dependency of check_parameters, header, local_stop,
-# pmc_handle_communicator
+# 
 # 
 # Former revisions:
 # -----------------
 # $Id$
-# 
+#
+# 1764 2016-02-28 12:45:19Z raasch
+# several updates of dependencies
+#
 # 1762 2016-02-25 12:31:13Z hellstea
 # +pmc_interface, +pmc routines 
Index: /palm/trunk/SOURCE/boundary_conds.f90
===================================================================
--- /palm/trunk/SOURCE/boundary_conds.f90	(revision 1764)
+++ /palm/trunk/SOURCE/boundary_conds.f90	(revision 1765)
@@ -19,9 +19,12 @@
 ! Current revisions:
 ! -----------------
-! index bug for u_p at left outflow removed
+!
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1764 2016-02-28 12:45:19Z raasch
+! index bug for u_p at left outflow removed
 !
 ! 1762 2016-02-25 12:31:13Z hellstea
Index: /palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- /palm/trunk/SOURCE/check_parameters.f90	(revision 1764)
+++ /palm/trunk/SOURCE/check_parameters.f90	(revision 1765)
@@ -19,10 +19,13 @@
 ! Current revisions:
 ! -----------------
-! output of nest id in run description header,
-! bugfix: check of validity of lateral boundary conditions moved to parin
 ! 
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1764 2016-02-28 12:45:19Z raasch
+! output of nest id in run description header,
+! bugfix: check of validity of lateral boundary conditions moved to parin
 !
 ! 1762 2016-02-25 12:31:13Z hellstea
Index: /palm/trunk/SOURCE/header.f90
===================================================================
--- /palm/trunk/SOURCE/header.f90	(revision 1764)
+++ /palm/trunk/SOURCE/header.f90	(revision 1765)
@@ -19,9 +19,12 @@
 ! Current revisions:
 ! -----------------
-! output of nesting informations
+!
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1764 2016-02-28 12:45:19Z raasch
+! output of nesting informations
 !
 ! 1697 2015-10-28 17:14:10Z raasch
Index: /palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- /palm/trunk/SOURCE/init_3d_model.f90	(revision 1764)
+++ /palm/trunk/SOURCE/init_3d_model.f90	(revision 1765)
@@ -19,9 +19,12 @@
 ! Current revisions:
 ! ------------------
-! bugfix: increase size of volume_flow_area_l and volume_flow_initial_l by 1
+!
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1764 2016-02-28 12:45:19Z raasch
+! bugfix: increase size of volume_flow_area_l and volume_flow_initial_l by 1
 !
 ! 1762 2016-02-25 12:31:13Z hellstea
Index: /palm/trunk/SOURCE/init_pegrid.f90
===================================================================
--- /palm/trunk/SOURCE/init_pegrid.f90	(revision 1764)
+++ /palm/trunk/SOURCE/init_pegrid.f90	(revision 1765)
@@ -19,9 +19,12 @@
 ! Current revisions:
 ! ------------------
-! cpp-statements for nesting removed
 ! 
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1764 2016-02-28 12:45:19Z raasch
+! cpp-statements for nesting removed
 !
 ! 1762 2016-02-25 12:31:13Z hellstea
Index: /palm/trunk/SOURCE/local_stop.f90
===================================================================
--- /palm/trunk/SOURCE/local_stop.f90	(revision 1764)
+++ /palm/trunk/SOURCE/local_stop.f90	(revision 1765)
@@ -19,9 +19,12 @@
 ! Current revisions:
 ! -----------------
-! abort with MPI_COMM_WORLD added, nested runs always abort with MPI_ABORT
 ! 
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1764 2016-02-28 12:45:19Z raasch
+! abort with MPI_COMM_WORLD added, nested runs always abort with MPI_ABORT
 !
 ! 1682 2015-10-07 23:56:08Z knoop
Index: /palm/trunk/SOURCE/message.f90
===================================================================
--- /palm/trunk/SOURCE/message.f90	(revision 1764)
+++ /palm/trunk/SOURCE/message.f90	(revision 1765)
@@ -19,11 +19,14 @@
 ! Current revisions:
 ! -----------------
-! nest id added to header string, add linefeed to stdout to get messages better
-! seperatedvfrom the location messages,
-! in case of nested runs, location messages are given only by the root domain
-! 
+! 
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1764 2016-02-28 12:45:19Z raasch
+! nest id added to header string, add linefeed to stdout to get messages better
+! seperated from the location messages,
+! in case of nested runs, location messages are given only by the root domain
 !
 ! 1682 2015-10-07 23:56:08Z knoop
Index: /palm/trunk/SOURCE/modules.f90
===================================================================
--- /palm/trunk/SOURCE/modules.f90	(revision 1764)
+++ /palm/trunk/SOURCE/modules.f90	(revision 1765)
@@ -19,9 +19,12 @@
 ! Current revisions:
 ! ------------------
-! some reformatting
+!
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1764 2016-02-28 12:45:19Z raasch
+! some reformatting
 !
 ! 1762 2016-02-25 12:31:13Z hellstea
Index: /palm/trunk/SOURCE/palm.f90
===================================================================
--- /palm/trunk/SOURCE/palm.f90	(revision 1764)
+++ /palm/trunk/SOURCE/palm.f90	(revision 1765)
@@ -19,9 +19,12 @@
 ! Current revisions:
 ! -----------------
-! cpp-statements for nesting removed, communicator settings cleaned up
+!
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1764 2016-02-28 12:45:19Z raasch
+! cpp-statements for nesting removed, communicator settings cleaned up
 !
 ! 1762 2016-02-25 12:31:13Z hellstea
Index: /palm/trunk/SOURCE/parin.f90
===================================================================
--- /palm/trunk/SOURCE/parin.f90	(revision 1764)
+++ /palm/trunk/SOURCE/parin.f90	(revision 1765)
@@ -19,4 +19,11 @@
 ! Current revisions:
 ! -----------------
+!
+!
+! Former revisions:
+! -----------------
+! $Id$
+!
+! 1764 2016-02-28 12:45:19Z raasch
 ! cpp-statements for nesting removed, explicit settings of boundary conditions
 ! in nest domains,
@@ -24,8 +31,4 @@
 ! bugfix: check of lateral boundary conditions from check_parameters to here,
 ! because they will be already used in init_pegrid and init_grid
-! 
-! Former revisions:
-! -----------------
-! $Id$
 !
 ! 1762 2016-02-25 12:31:13Z hellstea
Index: /palm/trunk/SOURCE/pmc_client.f90
===================================================================
--- /palm/trunk/SOURCE/pmc_client.f90	(revision 1764)
+++ /palm/trunk/SOURCE/pmc_client.f90	(revision 1765)
@@ -20,10 +20,13 @@
 ! Current revisions:
 ! ------------------
-! cpp-statement added (nesting can only be used in parallel mode),
-! all kinds given in PALM style
+!
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1764 2016-02-28 12:45:19Z raasch
+! cpp-statement added (nesting can only be used in parallel mode),
+! all kinds given in PALM style
 !
 ! 1762 2016-02-25 12:31:13Z hellstea
Index: /palm/trunk/SOURCE/pmc_general.f90
===================================================================
--- /palm/trunk/SOURCE/pmc_general.f90	(revision 1764)
+++ /palm/trunk/SOURCE/pmc_general.f90	(revision 1765)
@@ -20,10 +20,13 @@
 ! Current revisions:
 ! ------------------
-! cpp-statement added (nesting can only be used in parallel mode),
-! all kinds given in PALM style
+!
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1764 2016-02-28 12:45:19Z raasch
+! cpp-statement added (nesting can only be used in parallel mode),
+! all kinds given in PALM style
 !
 ! 1762 2016-02-25 12:31:13Z hellstea
Index: /palm/trunk/SOURCE/pmc_handle_communicator.f90
===================================================================
--- /palm/trunk/SOURCE/pmc_handle_communicator.f90	(revision 1764)
+++ /palm/trunk/SOURCE/pmc_handle_communicator.f90	(revision 1765)
@@ -20,4 +20,11 @@
 ! Current revisions:
 ! ------------------
+!
+!
+! Former revisions:
+! -----------------
+! $Id$
+!
+! 1764 2016-02-28 12:45:19Z raasch
 ! pmc_layout type: comm_cpl and comm_parent removed, character "name" moved at
 ! the beginning of the variable list,
@@ -26,8 +33,4 @@
 ! variable domain_layouts instead of m_couplers introduced for this NAMELIST,
 ! general format changed to PALM style
-!
-! Former revisions:
-! -----------------
-! $Id$
 !
 ! 1762 2016-02-25 12:31:13Z hellstea
Index: /palm/trunk/SOURCE/pmc_interface.f90
===================================================================
--- /palm/trunk/SOURCE/pmc_interface.f90	(revision 1764)
+++ /palm/trunk/SOURCE/pmc_interface.f90	(revision 1765)
@@ -20,4 +20,11 @@
 ! Current revisions:
 ! ------------------
+!
+!
+! Former revisions:
+! -----------------
+! $Id$
+!
+! 1764 2016-02-28 12:45:19Z raasch
 ! +cpl_parent_id,
 ! cpp-statements for nesting replaced by __parallel statements,
@@ -25,8 +32,4 @@
 ! index bugfixes in pmci_interp_tril_all,
 ! some adjustments to PALM style
-!
-! Former revisions:
-! -----------------
-! $Id$
 !
 ! 1762 2016-02-25 12:31:13Z hellstea
Index: /palm/trunk/SOURCE/pmc_mpi_wrapper.f90
===================================================================
--- /palm/trunk/SOURCE/pmc_mpi_wrapper.f90	(revision 1764)
+++ /palm/trunk/SOURCE/pmc_mpi_wrapper.f90	(revision 1765)
@@ -20,10 +20,13 @@
 ! Current revisions:
 ! ------------------
-! cpp-statement added (nesting can only be used in parallel mode),
-! kind-parameters adjusted to PALM-kinds
+!
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1764 2016-02-28 12:45:19Z raasch
+! cpp-statement added (nesting can only be used in parallel mode),
+! kind-parameters adjusted to PALM-kinds
 !
 ! 1762 2016-02-25 12:31:13Z hellstea
Index: /palm/trunk/SOURCE/pmc_server.f90
===================================================================
--- /palm/trunk/SOURCE/pmc_server.f90	(revision 1764)
+++ /palm/trunk/SOURCE/pmc_server.f90	(revision 1765)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! ------------------
-! cpp-statement added (nesting can only be used in parallel mode)
+!
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1764 2016-02-28 12:45:19Z raasch
+! cpp-statement added (nesting can only be used in parallel mode)
 !
 ! 1762 2016-02-25 12:31:13Z hellstea
Index: /palm/trunk/SOURCE/time_integration.f90
===================================================================
--- /palm/trunk/SOURCE/time_integration.f90	(revision 1764)
+++ /palm/trunk/SOURCE/time_integration.f90	(revision 1765)
@@ -19,10 +19,13 @@
 ! Current revisions:
 ! ------------------
-! PMC_ACTIVE flags removed,
-! nest synchronization after first call of timestep
+!
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1764 2016-02-28 12:45:19Z raasch
+! PMC_ACTIVE flags removed,
+! bugfix: nest synchronization after first call of timestep
 !
 ! 1762 2016-02-25 12:31:13Z hellstea