Index: palm/trunk/SOURCE/Makefile
===================================================================
--- palm/trunk/SOURCE/Makefile	(revision 1779)
+++ palm/trunk/SOURCE/Makefile	(revision 1780)
@@ -20,9 +20,12 @@
 # Current revisions:
 # ------------------
-# dependencies changed for init_peprid
+# 
 # 
 # Former revisions:
 # -----------------
 # $Id$
+#
+# 1779 2016-03-03 08:01:28Z raasch
+# dependencies changed for init_peprid
 #
 # 1766 2016-02-29 08:37:15Z raasch
Index: palm/trunk/SOURCE/check_open.f90
===================================================================
--- palm/trunk/SOURCE/check_open.f90	(revision 1779)
+++ palm/trunk/SOURCE/check_open.f90	(revision 1780)
@@ -19,10 +19,13 @@
 ! Current revisions:
 ! -----------------
-! coupling_char is trimmed at every place it occurs, because it can have
-! different length now
 ! 
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1779 2016-03-03 08:01:28Z raasch
+! coupling_char is trimmed at every place it occurs, because it can have
+! different length now
 !
 ! 1745 2016-02-05 13:06:51Z gronemeier
Index: palm/trunk/SOURCE/init_grid.f90
===================================================================
--- palm/trunk/SOURCE/init_grid.f90	(revision 1779)
+++ palm/trunk/SOURCE/init_grid.f90	(revision 1780)
@@ -19,10 +19,13 @@
 ! Current revisions:
 ! -----------------
-! coupling_char is trimmed at every place it occurs, because it can have
-! different length now
+!
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1779 2016-03-03 08:01:28Z raasch
+! coupling_char is trimmed at every place it occurs, because it can have
+! different length now
 !
 ! 1762 2016-02-25 12:31:13Z hellstea
Index: palm/trunk/SOURCE/init_pegrid.f90
===================================================================
--- palm/trunk/SOURCE/init_pegrid.f90	(revision 1779)
+++ palm/trunk/SOURCE/init_pegrid.f90	(revision 1780)
@@ -19,10 +19,13 @@
 ! Current revisions:
 ! ------------------
-! changes regarding nested domain removed: virtual PE grid will be automatically
-! calculated for nested runs too
+!
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1779 2016-03-03 08:01:28Z raasch
+! changes regarding nested domain removed: virtual PE grid will be automatically
+! calculated for nested runs too
 !
 ! 1764 2016-02-28 12:45:19Z raasch
Index: palm/trunk/SOURCE/interaction_droplets_ptq.f90
===================================================================
--- palm/trunk/SOURCE/interaction_droplets_ptq.f90	(revision 1779)
+++ palm/trunk/SOURCE/interaction_droplets_ptq.f90	(revision 1780)
@@ -19,10 +19,13 @@
 ! Current revisions:
 ! -----------------
-! module procedure names shortened to avoid Intel compiler warnings about too
-! long names
 ! 
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1779 2016-03-03 08:01:28Z raasch
+! bugfix: module procedure names shortened to avoid Intel compiler warnings
+! about too long names
 !
 ! 1682 2015-10-07 23:56:08Z knoop
Index: palm/trunk/SOURCE/modules.f90
===================================================================
--- palm/trunk/SOURCE/modules.f90	(revision 1779)
+++ palm/trunk/SOURCE/modules.f90	(revision 1780)
@@ -19,9 +19,12 @@
 ! Current revisions:
 ! ------------------
-! coupling_char extended to LEN=3
+!
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1779 2016-03-03 08:01:28Z raasch
+! coupling_char extended to LEN=3
 !
 ! 1764 2016-02-28 12:45:19Z raasch
Index: palm/trunk/SOURCE/palm.f90
===================================================================
--- palm/trunk/SOURCE/palm.f90	(revision 1779)
+++ palm/trunk/SOURCE/palm.f90	(revision 1780)
@@ -19,9 +19,12 @@
 ! Current revisions:
 ! -----------------
-! setting of nest_domain and coupling_char moved to the pmci
+!
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1779 2016-03-03 08:01:28Z raasch
+! setting of nest_domain and coupling_char moved to the pmci
 !
 ! 1764 2016-02-28 12:45:19Z raasch
Index: palm/trunk/SOURCE/pmc_client.f90
===================================================================
--- palm/trunk/SOURCE/pmc_client.f90	(revision 1779)
+++ palm/trunk/SOURCE/pmc_client.f90	(revision 1780)
@@ -20,10 +20,13 @@
 ! Current revisions:
 ! ------------------
-! kind=dp replaced by wp, dim_order removed
-! array management changed from linked list to sequential loop
+!
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1779 2016-03-03 08:01:28Z raasch
+! kind=dp replaced by wp, dim_order removed
+! array management changed from linked list to sequential loop
 !
 ! 1764 2016-02-28 12:45:19Z raasch
Index: palm/trunk/SOURCE/pmc_general.f90
===================================================================
--- palm/trunk/SOURCE/pmc_general.f90	(revision 1779)
+++ palm/trunk/SOURCE/pmc_general.f90	(revision 1780)
@@ -20,10 +20,13 @@
 ! Current revisions:
 ! ------------------
-! PMC_MPI_REAL removed, dim_order removed from type arraydef,
-! array management changed from linked list to sequential loop
+!
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1779 2016-03-03 08:01:28Z raasch
+! PMC_MPI_REAL removed, dim_order removed from type arraydef,
+! array management changed from linked list to sequential loop
 !
 ! 1766 2016-02-29 08:37:15Z raasch
Index: palm/trunk/SOURCE/pmc_handle_communicator.f90
===================================================================
--- palm/trunk/SOURCE/pmc_handle_communicator.f90	(revision 1779)
+++ palm/trunk/SOURCE/pmc_handle_communicator.f90	(revision 1780)
@@ -20,10 +20,13 @@
 ! Current revisions:
 ! ------------------
-! only the total number of PEs is given in the nestpar-NAMELIST,
-! additional comments included
+!
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1779 2016-03-03 08:01:28Z raasch
+! only the total number of PEs is given in the nestpar-NAMELIST,
+! additional comments included
 !
 ! 1764 2016-02-28 12:45:19Z raasch
Index: palm/trunk/SOURCE/pmc_interface.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface.f90	(revision 1779)
+++ palm/trunk/SOURCE/pmc_interface.f90	(revision 1780)
@@ -20,11 +20,15 @@
 ! Current revisions:
 ! ------------------
-! only the total number of PEs is given for the domains, npe_x and npe_y
-! replaced by npe_total,
-! array management changed from linked list to sequential loop
+!
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1779 2016-03-03 08:01:28Z raasch
+! only the total number of PEs is given for the domains, npe_x and npe_y
+! replaced by npe_total, two unused elements removed from array
+! define_coarse_grid_real,
+! array management changed from linked list to sequential loop
 !
 ! 1766 2016-02-29 08:37:15Z raasch
Index: palm/trunk/SOURCE/pmc_mpi_wrapper.f90
===================================================================
--- palm/trunk/SOURCE/pmc_mpi_wrapper.f90	(revision 1779)
+++ palm/trunk/SOURCE/pmc_mpi_wrapper.f90	(revision 1780)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! ------------------
-! kind=dp replaced by wp
+!
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1779 2016-03-03 08:01:28Z raasch
+! kind=dp replaced by wp
 !
 ! 1764 2016-02-28 12:45:19Z raasch
Index: palm/trunk/SOURCE/pmc_server.f90
===================================================================
--- palm/trunk/SOURCE/pmc_server.f90	(revision 1779)
+++ palm/trunk/SOURCE/pmc_server.f90	(revision 1780)
@@ -20,11 +20,14 @@
 ! Current revisions:
 ! ------------------
+!
+!
+! Former revisions:
+! -----------------
+! $Id$
+!
+! 1779 2016-03-03 08:01:28Z raasch
 ! kind=dp replaced by wp,
 ! error messages removed or changed to PALM style, dim_order removed
 ! array management changed from linked list to sequential loop
-!
-! Former revisions:
-! -----------------
-! $Id$
 !
 ! 1766 2016-02-29 08:37:15Z raasch